<template>
  <div>
    <v-container md="8">
      <v-row justify="center">
        <v-col>
          <v-autocomplete
            v-model="data.value"
            :items="cecos"
            item-text="descripcion"
            item-value="idCeco"
            label="Escribe el ceco que deses buscar."
            :cache-items="false"
            single-line
            return-object
            :search-input.sync="textoIngresado"
            :filter="customFilter"
            @keyup="getCecos()"
            @change="seleccionCeco()"
          ></v-autocomplete>
        </v-col>
      </v-row>
      <v-row>
        <v-col>
          <div v-if="noExisteCeco">
            <v-text-field
              v-model="cecoT"
              maxlength="6"
              placeholder="Digita el ceco"
              ref="txtCeco"
              @input="digitarCeco()"
              counter
            />
          </div>
          <v-checkbox
            v-model="noExisteCeco"
            :label="`No encontraste tu ceco?`"
          ></v-checkbox>
        </v-col>
      </v-row>
    </v-container>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
export default {
  name: "Component-Busqueda-Ceco",
  props: {
    value: Object,
    callback: { type: Function },
  },
  set(value) {
    this.$emit("input", value);
  },
  computed: {
    data: {
      textoCeco: null,
      get() {
        return this.value;
      },
      set(value) {
        this.$emit("input", value);
      },
    },
  },
  data() {
    return {
      cecos: [],
      textoIngresado: null,
      noExisteCeco: false,
      cecoT: null,
    };
  },
  methods: {
    customFilter(item, queryText, itemText) {
      const textOne = item.descripcion.toLowerCase();
      const textTwo = item.idCeco.toString();
      const searchText = queryText.toLowerCase();
      return (
        textOne.indexOf(searchText) > -1 || textTwo.indexOf(searchText) > -1
      );
    },
    getNegocios() {
      axios
        .post("/negoVers/secure/post/negocio", {
          idNegocio: null,
        })
        .then((response) => {
          //console.log(JSON.stringify(response.data.data))
          if (response) {
            if (response.status === 200) {
              if (response.data.data != undefined) {
                this.metadata.negocios = response.data.data;
                this.metadata.cecos = [];
                this.habilitaSuc = false;
              }
            }
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    }, //fin negocios
    getCecos() {
      var self = this;
      axios
        .post("/documento-sucursal/ceco/v1/busquedas/", {
          idNegocio: null,
          ceco: this.textoIngresado,
        })
        .then((response) => {
          let data = response.data;
          if (data) {
            self.cecos = data.resultado.cecos;
          }
        })
        .catch((error) => {
          if (error.response) {
            if (error.response.status == 404) {
              this.noExisteCeco = true;
            }
            console.log(error.response.data);
          }
        });
    },
    seleccionCeco() {
      this.callback(this.value.value.idCeco, this.value.value.descripcion);
    },
    digitarCeco() {
      console.log("digitarCeco");
      if (this.cecoT.length == 6) {
        this.callback(this.cecoT, "");
      }
    },
  },
};
</script>